// Wima_CB FormatterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Wima_CB Formatter.h"
#include "Wima_CB FormatterDlg.h"

#include "shlwapi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

BOOL WimaDiskOK;

DWORD CALLBACK Test(DWORD dwEvent, DWORD dwEventParam, DWORD dwWin32Err, LPVOID lpParam, LPVOID lpUsrParam)
{
	CWima_CBFormatterDlg * dlg = (CWima_CBFormatterDlg*) theApp.m_pMainWnd;

	switch ( dwEvent )
	{
	case DWEV_PROGRESSPERCENT:
		dlg->DiskProgress.SetPos ( dwEventParam );
		//DiskProgress.SetPos( dwEventParam );
		return 0;
	case DWEV_ERRORSUPINFO:
		return 2;
	case DWEV_ERRORWIN32:
		return 0;
	}
	return 0;
}
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CWima_CBFormatterDlg dialog



CWima_CBFormatterDlg::CWima_CBFormatterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWima_CBFormatterDlg::IDD, pParent)
	, NrDisks(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWima_CBFormatterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_NRDISKS, NrDisk);
	DDX_Control(pDX, IDC_SPINNRDISKS, SpinNr);
	DDX_Control(pDX, IDC_DISKPROG, DiskProgress);
	DDX_Control(pDX, IDC_JOBPROGRESS, JobProgress);
	DDX_Control(pDX, IDC_CBDRIVE, DriveLetter);
}

BEGIN_MESSAGE_MAP(CWima_CBFormatterDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RESETWima_CB, OnBnClickedResetWima_CB)
	ON_BN_CLICKED(IDC_FRMTALL, OnBnClickedFrmtall)
	ON_WM_SHOWWINDOW()
END_MESSAGE_MAP()


// CWima_CBFormatterDlg message handlers

BOOL CWima_CBFormatterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	DiskProgress.SetRange( 0, 100 );
    NrDisk.SetWindowText("1");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWima_CBFormatterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWima_CBFormatterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWima_CBFormatterDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CWima_CBFormatterDlg::OnBnClickedResetWima_CB()
{
}



void CWima_CBFormatterDlg::OnBnClickedFrmtall()
{
	int i, j;
	CString s;
	HIMA hIma  = CreateMemFatHima();
	EVENTNOTIFCALLBACK MyFunc;
	BOOL DiskOK;
	
	//MFC variabelen aanpassen
	UpdateData( TRUE );

	MyFunc = (EVENTNOTIFCALLBACK) Test;

	//Hoeveel diskettes moeten geformatteerd worden?
	NrDisk.GetWindowText( s );
	j = StrToInt( s );
	//Progressbar instellen op correcte waarden
	JobProgress.SetRange( 0, j );
	JobProgress.SetPos( 0 );

	//lege image maken voor WinImage
	MakeEmptyImage( hIma, 6);
	if ( hIma )
	{
		//Image maken is gelukt
		for ( i = 0; i < j; i++ )
		{
			//Diskette laden in Wima_CB station
			
			//Als er niets fout gegaan is doen we verder		
			WimaDiskOK = TRUE;
			DiskOK = WriteFloppyCB( hIma, NULL ,MyFunc, NULL,DriveLetter.GetCurSel(), ALL, USED, NOTHING, 0);

			DiskProgress.SetPos( 100 ); 
			if (!DiskOK)
            {
                MessageBox("The format/write operation has failed");
                break;
            }

			//Wachten op resultaat van Wima_CB

			//ProgressBar aanpassen
			JobProgress.SetPos( i + 1);
            if (i+1<j)
                MessageBox("Insert a new floppy");
		}
	}

}
static BOOL IsFloppyDrive(int iFloppy)
{
    DRIVEINFO driveInfo = GetDriveInfo((BYTE)iFloppy);
    if ((driveInfo==FLOPPY_360) || (driveInfo==FLOPPY_12M) ||
        (driveInfo==FLOPPY_720) || (driveInfo==FLOPPY_144) ||
        (driveInfo==FLOPPY_288))
        return TRUE;
    return FALSE;
}


void CWima_CBFormatterDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
	int i;
	CDialog::OnShowWindow(bShow, nStatus);
	
	SpinNr.SetRange( 0,30);

	DriveLetter.Clear();
	for ( i = 0; i < 26; i++ )
	{
		if (IsFloppyDrive(i))
		{
			char szDrive[10] = "::";
			szDrive[0] = i + 'A';
			DriveLetter.AddString( szDrive );
		}
	}
	DriveLetter.SetCurSel( 0 );
	UpdateData( FALSE );
}
